//+------------------------------------------------------------------+
//|                                            Multi weighted MA.mq5 |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 3
#property indicator_plots   1
#property indicator_label1  "Multi weighted MA"
#property indicator_type1   DRAW_COLOR_LINE
#property indicator_color1  clrDeepSkyBlue,clrDarkOrange,clrDimGray
#property indicator_style1  STYLE_SOLID
#property indicator_width1  2

//
//
//
//
//

input int Length = 10;
input int Depth  = 2;

//
//
//
//
//

double mwma[];
double colorBuffer[];
int tDepth;

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

int OnInit()
{
   SetIndexBuffer(0,mwma,INDICATOR_DATA); PlotIndexSetInteger(0,PLOT_COLOR_INDEXES,3);
   SetIndexBuffer(1,colorBuffer,INDICATOR_COLOR_INDEX); 
      tDepth = MathMax(MathMin(Depth,25),1);
   IndicatorSetString(INDICATOR_SHORTNAME,"Multi weighted MA ("+string(Length)+","+string(tDepth)+")");
   return(0);
}

//
//
//
//
//

int OnCalculate (const int rates_total,
                 const int prev_calculated,
                 const int begin,
                 const double& price[] )
{
   for (int i=(int)MathMax(prev_calculated-1,0); i<rates_total; i++)
   {
      double tprice = price[i];
         for (int k=0; k<tDepth; k++)
                tprice = iLwma(tprice,Length,rates_total,i,k);
      mwma[i] = tprice;              
      if (i>0)
      {
         colorBuffer[i] = 2;
            if (mwma[i]>mwma[i-1]) colorBuffer[i]=0;
            if (mwma[i]<mwma[i-1]) colorBuffer[i]=1;
      }
   }      
   return(rates_total);
}


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workLwma[][25];
double iLwma(double price, double period, int bars, int r, int instanceNo=0)
{
   if (ArrayRange(workLwma,0)!= bars) ArrayResize(workLwma,bars);
   
   //
   //
   //
   //
   //
   
   workLwma[r][instanceNo] = price;
      double sumw = period;
      double sum  = period*price;

      for(int k=1; k<period && (r-k)>=0; k++)
      {
         double weight = period-k;
                sumw  += weight;
                sum   += weight*workLwma[r-k][instanceNo];  
      }             
      return(sum/sumw);
}
